#ifndef FORM_H
#define FORM_H

#include <vector>
#include <iostream>
#include <sstream>


class Rectangle;         // prédéclaration de la classe Rectangle
typedef Rectangle Bbox;  // le type Bbox est synonyme de Rectangle

class Form
{
public:
    Form(double x=0, double y=0);
    virtual ~Form(){};

    double get_x() ;
    double get_y() ;

    virtual void affiche()=0 ;  // méthode virtuelle pure
    virtual Bbox get_bbox()=0 ; // méthode virtuelle pure

protected:
    double x,y;
};

class Circle: public Form
{
public:
    Circle(double x=0, double y=0, double radius=0);

    double get_radius();

    virtual void affiche() override ; 
    virtual Bbox get_bbox() override ;

private:
    double radius;
};

class Square: public Form
{
public:
    Square(double x=0, double y=0, double side=0);
    double get_side();

    virtual void affiche() override ; 
    virtual Bbox get_bbox() override ;

private:
    double side;
};

class Rectangle: public Form
{
public:
    Rectangle(double x=0, double y=0, double width=0, double height=0);

    double get_width() ;
    double get_height() ;

    virtual void affiche() override ; 
    virtual Bbox get_bbox() override ;

    Bbox merge_bbox(Bbox& other);
    bool intersect_bbox(Bbox& other);

private:
    double width, height;
};

std::ostream & operator<<(std::ostream & o, Form * f);

#endif
