#include <vector>
#include <cstdlib>
#include <string>
#include <iostream>
#include <fstream>
#include <sstream>


#include "form.h"
#include "formset.h"

using namespace std;

// symboles et type pour codes d'erreurs
enum Erreur_lecture {LECTURE_ARG, LECTURE_OUVERTURE};
enum Etat_lecture {NB_FORMSET, LECTURE_FORMSET};

void erreur(Erreur_lecture code);
void lecture(string nom_fichier);

int main(int argc, char * argv[])
{
	if(argc != 2) 
		erreur(LECTURE_ARG);

	string filename(argv[1]);
	lecture(filename);
	
	affiche_formset_valid();

	return EXIT_SUCCESS;
}

// affiche un message d'erreur puis quitte le programme
void erreur(Erreur_lecture code)
{
	switch(code)
	{
	    case LECTURE_ARG : cout << " nom de fichier manquant\n";  break;
	    case LECTURE_OUVERTURE: cout << " ouverture impossible\n";break;
	    default: cout << " erreur inconnue\n";
	}
	exit(EXIT_FAILURE);
}


// traite le fichier ligne par ligne.  
void lecture(string nom_fichier)
{
    ifstream ifs;
	Formset fs;
	ifs.open(nom_fichier, ios::in); 
    if(!ifs.fail()) 
    {
		string line;
		size_t formset_num(0);
		
		while(getline(ifs>>ws, line))
		{
			if(line[0]=='#') continue;
			// etat : lecture du nombre de Formsets;
			istringstream data(line);
			data >> formset_num ;
			break;
		}

		// boucle de lecture des Formset avec délégation à Formset
		for(size_t i(0) ; i< formset_num ; ++i)
		{
			Formset fs;
			formset_lecture(ifs, fs);
			if(fs.no_intersect_with_set())
			{
				cout << "Success: the latest Formset has no intersection" << endl;
				add_formset(fs);
			}
			else 
			{
				cout << "Failure: the latest Formset cannot be added" << endl; 
				fs.delete_forms();
			}
		}
		ifs.close();	
	}
	else 
		erreur(LECTURE_OUVERTURE);
}
