#include <iostream>
#include "layoutbuttons.h"

using namespace std;

LayoutButtons::LayoutButtons() :
  m_Box_Top(Gtk::Orientation::VERTICAL,10),
  m_Box1(Gtk::Orientation::HORIZONTAL,10),
  m_Box2(Gtk::Orientation::HORIZONTAL,10),
  m_Label_Salutation("Formule de Salutation"),
  m_Label_Destinataire("A qui s'adresse-t-on ?"),
  m_Label_Fin("Les meilleures choses ont une fin\n" 
              "éventuellement sur plusieurs lignes"),
  m_Button_Hello("Hello"),
  m_Button_Bonjour("Bonjour"),
  m_Button_Monsieur("Monsieur"),
  m_Button_Madame("Madame"),
  m_Button_Fin("Fin")
{
  // Set title and border of the window
  set_title("layout buttons");

  // Add outer box to the window (because the window
  // can only contain a single widget)
  set_child(m_Box_Top);
    
  //Put the inner boxes and the separator in the outer box:
  m_Box_Top.append(m_Label_Salutation);
  m_Box_Top.append(m_Box1);
  m_Box_Top.append(m_Separator1);
  m_Box_Top.append(m_Label_Destinataire);
  m_Box_Top.append(m_Box2);
  m_Box_Top.append(m_Separator2);
  m_Box_Top.append(m_Label_Fin);
  m_Box_Top.append(m_Button_Fin);

  // Put Hello / Bonjour buttons in Box1:
  m_Box1.append(m_Button_Hello);
  m_Box1.append(m_Button_Bonjour);

  // Put Madame / Monsieur buttons in Box2:
  m_Box2.append(m_Button_Madame);
  m_Box2.append(m_Button_Monsieur);

  m_Box1.set_halign(Gtk::Align::CENTER);
  m_Box2.set_halign(Gtk::Align::CENTER);


  // Connect the clicked signal of the button to
  // thier signal handler
  m_Button_Hello.signal_clicked().connect(sigc::mem_fun(*this,
              &LayoutButtons::on_button_clicked_Hello) );

  m_Button_Bonjour.signal_clicked().connect(sigc::mem_fun(*this,
              &LayoutButtons::on_button_clicked_Bonjour) );

  m_Button_Monsieur.signal_clicked().connect(sigc::mem_fun(*this,
              &LayoutButtons::on_button_clicked_Monsieur) );

  m_Button_Madame.signal_clicked().connect(sigc::mem_fun(*this,
              &LayoutButtons::on_button_clicked_Madame) );

  m_Button_Fin.signal_clicked().connect(sigc::mem_fun(*this,
              &LayoutButtons::on_button_clicked_Fin) );
}

LayoutButtons::~LayoutButtons()
{
}

void LayoutButtons::on_button_clicked_Hello()
{
  cout << "Hello " ;
}

void LayoutButtons::on_button_clicked_Bonjour()
{
  cout << "Bonjour " ;
}

void LayoutButtons::on_button_clicked_Monsieur()
{
  cout << "Monsieur" << endl;
}

void LayoutButtons::on_button_clicked_Madame()
{
  cout << "Madame" << endl;
}

void LayoutButtons::on_button_clicked_Fin()
{
  hide(); //to close the application.
}
